sc::DiagMolecularHessian Class Reference

DiagMolecularHessian is an implementation of MolecularHessian that returns a hessian that is a diagonal matrix. More...

`#include <hess.h>`

Inheritance diagram for sc::DiagMolecularHessian:
[legend]
Collaboration diagram for sc::DiagMolecularHessian:
[legend]

## Public Member Functions

| DiagMolecularHessian (const Ref< KeyVal > &)
| The DiagMolecularHessian KeyVal constructor is used to generate a DiagMolecularHessian object from the input. More...
| DiagMolecularHessian (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
RefSymmSCMatrix | cartesian_hessian ()
| Return the hessian in cartesian coordinates.
Public Member Functions inherited from sc::MolecularHessian
| MolecularHessian (const Ref< KeyVal > &)
| The MolecularHessian KeyVal constructor is used to generate a MolecularHessian derivative object from the input. More...
| MolecularHessian (StateIn &)
RefSCDimension | d3natom ()
Ref< SCMatrixKit > | matrixkit () const
virtual void | set_energy (const Ref< MolecularEnergy > &energy)
| Some MolecularHessian specializations require a molecular energy object. More...
virtual MolecularEnergy * | energy () const
| This returns a MolecularEnergy object, if used by this specialization. More...
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Attributes

double | diag_
Protected Attributes inherited from sc::MolecularHessian
Ref< Molecule > | mol_
RefSCDimension | d3natom_
Ref< SCMatrixKit > | matrixkit_

## Additional Inherited Members

Static Public Member Functions inherited from sc::MolecularHessian
static RefSCMatrix | cartesian_to_symmetry (const Ref< Molecule > &m, Ref< PointGroup > pg=0, Ref< SCMatrixKit > kit=0)
| Find transformation matrix from cartesian to symmetry coordinates. More...
static void | write_cartesian_hessian (const char *filename, const Ref< Molecule > &m, const RefSymmSCMatrix &hess)
| Write the hessian in a simple text format.
static void | read_cartesian_hessian (const char *filename, const Ref< Molecule > &m, const RefSymmSCMatrix &hess)
| Read the hessian from a simple text format.
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

DiagMolecularHessian is an implementation of MolecularHessian that returns a hessian that is a diagonal matrix.

## Constructor & Destructor Documentation

sc::DiagMolecularHessian::DiagMolecularHessian | ( | const Ref< KeyVal > & |  | ) |

The DiagMolecularHessian KeyVal constructor is used to generate a DiagMolecularHessian object from the input.

It reads the keywords below.

Keyword | Type | Default | Description
`diag` | double | 1.0 | Specifies the diagonal elements of the hessian.

## Member Function Documentation

void sc::DiagMolecularHessian::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::MolecularHessian.

The documentation for this class was generated from the following file:

- hess.h